#include "tensor3d.h"

ostream& operator<<( ostream& out, tensor3d& t){
	out << "confidence: " << t.confidence << endl;
/*	for(int row = 0; row < 3; ++row){
		for(int col = 0; col < 3; ++col){
			out << t.matrix(row, col) << "\t";
		}
		out << endl;
	}*/

	cout << t.matrix << endl;

	return out;
}

vector3f* tensor3d::eigenvalues(){
	Eigen::EigenSolver<Eigen::MatrixXd> es(this->matrix);
//	Eigen::Vector3cf eigenvalues = es.eigenvalues();
	/*
	float e0 = es.eigenvalues()(0).real();
	float e1 = es.eigenvalues()(1).real();
	float e2 = es.eigenvalues()(2).real();*/

//	cout << this->matrix << endl << endl;

//	cout << es.eigenvalues() << endl;
	
//	cout << es.eigenvectors() << endl;
	
	/*
	cout << e0 << endl;
	cout << e1 << endl;
	cout << e2 << endl;*/

	/*
	if(e0 >= e1 >= e2){ this->major = e0; this->medium = e1; this->minor = e2;}
	if(e0 >= e2 >= e1){ this->major = e0; this->medium = e2; this->minor = e1;}
	if(e1 >= e0 >= e2){ this->major = e1; this->medium = e0; this->minor = e2;}
	if(e1 >= e2 >= e0){ this->major = e1; this->medium = e2; this->minor = e0;}
	if(e2 >= e0 >= e2){ this->major = e2; this->medium = e0; this->minor = e1;}
	if(e2 >= e1 >= e0){ this->major = e2; this->medium = e1; this->minor = e0;}*/
	this->major = 0;
	this->medium = 0;
	this->minor = 0;


	this->major_col = -1;
	this->medium_col = -1;
	this->minor_col = -1;
	
	this->eigenval = new vector3f();

	for(int i = 0; i < 3; ++i){
//		if(i == 0) this->major = es.eigenvalues()(i).real();

		/*
		if(abs(this->major) < abs( es.eigenvalues()(i).real()) && abs( es.eigenvalues()(i).real()) != abs(this->medium)) {
//			cout << this->major << endl;
			if(this->major > this->medium ){
				this->medium = this->major;
				this->medium_col = this->major_col;
			}
			else{

			}

			this->major = es.eigenvalues()(i).real();
			this->major_col = i;
//			cout << this->major << endl;
			continue;
		}
		
		if(abs(this->medium) < abs( es.eigenvalues()(i).real() ) ){
//			cout << this->medium << endl;
			this->minor = this->medium;
			this->minor_col = this->medium_col;
			this->medium = es.eigenvalues()(i).real();
			this->medium_col = i;
//			cout << this->medium << endl;
			continue;
		}*/

		float eig = es.eigenvalues()(i).real();

		switch(i){
			case 0:
				this->eigenval->x = eig;
				break;
			case 1:
				this->eigenval->y = eig;
				break;
			case 2:
				this->eigenval->z = eig;
				break;
		}

		if(abs(eig) > abs(this->major) ){
			if(abs(this->major) > abs(this->medium)){
				this->minor = this->medium;
				this->minor_col = this->medium_col;
				this->medium = this->major;
				this->medium_col = this->major_col;
			} else{
				this->minor = this->major;
				this->minor_col = this->major_col;
			}

			this->major = eig;
			this->major_col = i;
			continue;
		}

		if(abs(eig) > abs(this->medium) ){
			this->minor = this->medium;
			this->minor_col = this->medium_col;

			this->medium = eig;
			this->medium_col = i;
			continue;
		}
		
		this->minor = eig;
		this->minor_col = i;
	}

	return this->eigenval;
}

float tensor3d::MD(){
	return ( (this->major + this->medium + this->minor)/3 );
}

void tensor3d::FA(){
	this->md = MD();
//	float numerator = sqrt(3) * sqrt(pow(this->major-this->md,2) + pow(this->medium-this->md,2) + pow(this->minor-this->md,2));
//	float denominator = sqrt(2) * sqrt(pow(this->major,2) + pow(this->medium,2) + pow(this->minor,2));
	this->fa = ( sqrt(3) * sqrt(pow(this->major-this->md,2) + pow(this->medium-this->md,2) + pow(this->minor-this->md,2)) )/ 
		( sqrt(2) * sqrt(pow(this->major,2) + pow(this->medium,2) + pow(this->minor,2)) );
}