#include <vector>
#include <cmath>
#include <iostream>

#include <Eigen/Dense>

#include "vector3f.h"

using namespace std;

#ifndef __TENSOR3D_H__
#define __TENSOR3D_H__

class tensor3d{
	friend ostream& operator<<( ostream&, tensor3d&);
	public:
		Eigen::MatrixXd matrix;
		float confidence;

		int x;
		int y;
		int z;

		/*
		float Dxx;
		float Dxy;
		float Dxz;
		float Dyx;
		float Dyy;
		float Dyz;
		float Dzx;
		float Dzy;
		float Dzz;
		*/

		float major;
		float medium;
		float minor;

		vector3f* eigenval;

		vector3f* major_vec;
		vector3f* medium_vec;
		vector3f* minor_vec;

		int major_col;
		int medium_col;
		int minor_col;

		float fa;
		float md;

//		Eigen::EigenSolver<Eigen::MatrixXd> es;

		tensor3d(){ matrix = Eigen::MatrixXd(3,3); }


		//calculate eigenvectors and eigenvalues
		void eigenvectors();
		vector3f* eigenvalues();

		float MD(); // mean diffusivity
		void FA(); // fractional anisotropy

		float lerp_derp(float v1, float v2, float point){
			return (v1 * (1-point) + v2 * point); // linear interpolation
		}


};

#endif